"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.hydrate = void 0;
const compat_1 = __importDefault(require("preact/compat"));
const isServer = typeof window === "undefined";
let id = 0;
const hydrate = (Component) => (props) => {
    id += 1;
    const scriptSrc = `
    window.__STATE__.components[${id}]={name:${JSON.stringify(Component.name)},props:${JSON.stringify(props)}}
  `;
    return (compat_1.default.createElement(compat_1.default.Fragment, null,
        isServer && (compat_1.default.createElement("script", { dangerouslySetInnerHTML: { __html: scriptSrc }, "data-cmp-id": id })),
        compat_1.default.createElement(Component, Object.assign({}, props))));
};
exports.hydrate = hydrate;
